From b8ebeb0e8406e3a8cb20795e1e90fdc43e9ce492 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 01 2020 06:54:26 +0000
Subject: [PATCH 1157/2232] Fix fn arg representation to eliminate warning on rust 1.46+


---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 1bcaa1e..b25d830 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -594,7 +594,7 @@ fn expand_rust_function_shim_impl(
                 quote!(#receiver_type::#ident)
             }
         },
-        None => quote!(__extern),
+        None => quote!(::std::mem::transmute::<*const (), #sig>(__extern)),
     };
     call.extend(quote! { (#(#vars),*) });
 
@@ -662,7 +662,7 @@ fn expand_rust_function_shim_impl(
     };
 
     let pointer = match invoke {
-        None => Some(quote!(__extern: #sig)),
+        None => Some(quote!(__extern: *const ())),
         Some(_) => None,
     };
 

